program Gravacao_e_leitura_de_arquivos;
uses
  crt;
const
  MAXIMO = 20;

type
  tipo_carro = record
                 modelo:string[30];
                 preco:real;
                 { demais informaes ... }
               end;

  tipo_cadastro = array [1..MAXIMO] of tipo_carro;

{
  Procedure Grava_Disco: Salva em disco um arquivo binrio contendo
                         o cadastro dos automveis da revenda
  Entrada: nome     - nome do arquivo de sada
           numcar   - nmero de carros que foram cadastrados na revenda
           cadastro - cadastro (array) contendo os dados sobre os carros

  Sada: arquivo em formato "binrio" salvo em disco.

  Observaes: esta rotina no pede confirmao, e caso o arquivo j
               exista no disco, ele ser apagado e re-escrito.

}
procedure grava_disco(nome:string; numcar:integer; var cadastro:tipo_cadastro);
var
  cont:integer;
  arquivo:File of tipo_carro;
begin
  assign(arquivo,nome);
  rewrite(arquivo);
  for cont:=1 to numcar
  do write(arquivo,cadastro[cont]);
  close(arquivo);
end;

{
  Procedure Ler_Disco: Carrega do disco um arquivo binrio contendo
                       o cadastro dos automveis da revenda
  Entrada: nome     - nome do arquivo de entrada

  Sada: numcar   - nmero de carros que foram cadastrados na revenda
         cadastro - cadastro contendo os dados dos carros lidos do disco

  Observaes: esta rotina no verifica se o arquivo j existe. Caso o
               arquivo no seja encontrado no disco, o programa  terminado
               devido a um erro de execuo (file not found).
  > Este problema poderia ser resolvido... vide o "help" do comando reset

}
procedure ler_disco(nome:string; var numcar:integer; var cadastro:tipo_cadastro);
var
  aux:integer;
  arquivo:File of tipo_carro;
begin
  assign(arquivo,nome);
  reset(arquivo);
  aux:=0;
  while not eof(arquivo)
  do begin
       aux:=aux+1;
       if aux > MAXIMO
       then begin
              writeln('ERRO! Existem carros demais cadastrados...');
              halt(1);    { Caso o array no permita armazenar todos }
            end;          { os carros descritos no arquivo, termina. }
       read(arquivo,cadastro[aux]);
     end;
  close(arquivo);
  numcar:=aux;
end;

var
  cad:tipo_cadastro;
  valor:real;
  loop:boolean;
  cont,x:integer;
begin
  clrscr;
  cont:=0;
  loop:=true;
  writeln('Digite o nome do carro igual a "FIM" para terminar a entrada de dados...');

  { Le dados dos carros }
  while loop
  do begin
       cont:=cont+1;
       write('Carro: ');
       readln(cad[cont].modelo);
       if (cad[cont].modelo = 'FIM') or (cont = MAXIMO)
       then loop:=false
       else begin
              write('Preo: ');
              readln(cad[cont].preco);
            end;
     end;

  { Salva em disco os dados }
  clrscr;
  writeln('Salvando dados no disco... ');
  grava_disco('carros.bin',cont,cad);
  writeln('Arquivo salvo! Pressione uma tecla para continuar...');
  readkey;

  { Apaga todo o cadastro... apaga os dados e
    zera a varivel que controla o total de carros armazenado no cadastro }
  clrscr;
  writeln('Apagando os dados... ');
  for x:=1 to cont
  do begin
       cad[x].modelo:='';
       cad[x].preco:=0.0;
     end;
  cont:=0;
  writeln('Dados apagados! Pressione uma tecla para continuar...');
  readkey;


  { Le o arquivo do disco }
  clrscr;
  writeln('Recuperando os dados salvos no disco... ');
  ler_disco('carros.bin',cont,cad);
  writeln('Arquivo lido! Pressione uma tecla para continuar...');
  readkey;

  { Exibe na tela os dados contidos no cadastro }
  clrscr;
  writeln('>> Listagem do cadastro <<');
  writeln;
  for x:=1 to cont
  do writeln('Modelo: ',cad[x].modelo:30, ' - Preo R$: ',cad[x].preco:6:2);
  writeln('Fim do cadastro!');
  writeln;
  writeln('Pressione "ENTER" para terminar a execuo do programa...');
  readln;
end.